'###################################
'####   Elmcie Pre-flight1      ####
'###################################


'Bascom generated fuse- and lockbit-setting.
$prog &HFF , &H3F , &HD1 , &H00

'Or in words:

'Set fuses for 16 MHz external crystal
'Startup time 16 CK + 64 ms
'Preserve EEPROM when chip is erased
'Set BOD-level to 4 Volt, and enable it
'Set Reset-vector to $0000

$hwstack = 48
$swstack = 16
$framesize = 40

$baud = 38400
$crystal = 16000000
$regfile = "m8def.dat"

Dim Runner As Word
Dim Dummy As Byte
Dim Ee_byte As Byte
Dim Empty_line_str As String * 16
Dim Tmp_word As Word

Empty_line_str = "                "

Sw1_n Alias Pinc.3
Sw2_n Alias Pinc.2
Backlight_hi Alias Portb.1
Spkr Alias Portc.4
Do_l Alias Portb.0
Elm_disch Alias Ddrd.6
Elm_low_treshold Alias Ddrd.4
N_elm3k3_lm311on Alias Portd.3
Power_hold Alias Portd.2
Sw3_null Alias Pind.2

'setup i/o
Ddrc = &B00010011
Portc = &B00001100

Ddrb = &B00111111
Portb = &B00000000

'Pull -up On D.2 Enabled - - > Holds Power After Power -up
Ddrd = &B01011010
Portd = &B00000100


Config Lcdpin = Pin , Db4 = Portb.2 , Db5 = Portb.3 , Db6 = Portb.4 , Db7 = Portb.5 , E = Portc.0 , Rs = Portc.1
Config Lcd = 16 * 2

Config Adc = Single , Prescaler = Auto , Reference = Internal
Start Adc



Cls
Cursor Off Noblink

Set N_elm3k3_lm311on
Reset Backlight_hi
Reset Do_l

Tmp_word = Getadc(5)                                        'dummy read as it's the first
Waitms 1
Tmp_word = Getadc(5)                                        'ADC5= 0.18 * Ubatt

If Tmp_word < 490 Then
   Sound Spkr , 75 , 3000
   Lcd "Battery too LOW"
Else
   'max. current
   Reset N_elm3k3_lm311on
   Set Backlight_hi
   Set Do_l
   Waitms 200
   Tmp_word = Getadc(5)                                     'we want to check the battery level under max. current draw
   'restore min. current consumption
   Set N_elm3k3_lm311on
   Reset Backlight_hi
   Reset Do_l
   Tmp_word = Tmp_word - 450                                'to get a nice readout like a score in school
   Shift Tmp_word , Right , 4                               'divide by 16
   Lcd "Battery Q = " ; Tmp_word
End If

Wait 2

Cls

Lcd "Pre-flight1"
Gosub Do_okay_sound

Wait 2

Cls

Lcd "Erasing EEPROM"
Dummy = &HFF
Runner = 0

For Runner = 0 To 511
   Writeeeprom Dummy , Runner
Next Runner

Cls
Lcd "EEPROM erased"
Gosub Do_okay_sound
Wait 1

Home Upper
Lcd "verifying ..."
Home Lower

Runner = 0
While Runner < 512
   Readeeprom Ee_byte , Runner
   If Ee_byte <> &HFF Then
      Lcd "EE " ; Runner ; " error"
      Gosub Do_error_sound
      Do                                                    'if error then hold here ...
      Loop
   End If
   Incr Runner
Wend
Wait 1

Gosub Do_okay_sound

Lcd "EEprom is empty"

Wait 1

'Continue only when all buttons are released
While Sw1_n = 0 Or Sw2_n = 0 Or Sw3_null = 1
Wend

Cls

Lcd "Button test .."
Home Lower

Do
   If Sw1_n = 0 Then
      Locate 2 , 1
      Lcd "  1  "
   Else
      Locate 2 , 1
      Lcd "     "
   End If

   If Sw2_n = 0 Then
      Locate 2 , 6
      Lcd "  2  "
   Else
      Locate 2 , 6
      Lcd "     "
   End If

   If Sw3_null = 1 Then
      Locate 2 , 11
      Lcd "  3  "
   Else
      Locate 2 , 11
      Lcd "     "
   End If
Loop Until Sw1_n = 0 And Sw2_n = 0 And Sw3_null = 1

Cls
Lcd "OK, release"
Home Lower
Lcd "  all buttons"


'Wait for release
While Sw1_n = 0 Or Sw2_n = 0 Or Sw3_null = 1
Wend

Gosub Do_okay_sound

Wait 1



Cls
Lcd "1 sec beeps ?"
Home Lower
Lcd "B1=OK B2=error"

While Sw1_n = 1 And Sw2_n = 1
   Sound Spkr , 30 , 2500
   Wait 1
Wend

Cls

If Sw1_n = 0 Then
   Lcd "Xtal = 16MHz"
End If

If Sw2_n = 0 Then
   Lcd "wrong Xtal freq"
   Do                                                       'if error then hold here ...
   Loop
End If

Wait 1

Gosub Do_okay_sound

Wait 1

Cls
Lcd "Backlight high"
Home Lower
Lcd "B1=on B2=exit"

While Sw2_n = 1
   If Sw1_n = 0 Then
      Set Backlight_hi
   Else
      Reset Backlight_hi
   End If
Wend

Gosub Do_okay_sound

Wait 1

Cls
Lcd "Relay test"
Home Lower
Lcd "B1=on B2=exit"

While Sw2_n = 1
   If Sw1_n = 0 Then
      Set Do_l
   Else
      Reset Do_l
   End If
Wend

Gosub Do_okay_sound


Cls
Lcd "Pre-test1 ready"
Home Lower
Lcd "[halted]"


End

'_________________________________ SUBs __________________________________________

Do_okay_sound:

   Sound Spkr , 10 , 5000
   Waitms 100
   Sound Spkr , 30 , 2500

   Wait 1

   Return


Do_error_sound:

   Sound Spkr , 100 , 10000

   Wait 1

   Return