'###################################
'####   Elmcie Pre-flight3      ####
'###################################


'Enter here the value of YOUR Elcie's cal cap : but in 0.1 pF's !!!
Const C_cal2 = 19968                                        'so my cal cap is 1996.8 pF

'Pre-flight3 will store the Elcie-calibration values in EEprom

'Bascom generated fuse- and lockbit-setting.
$prog &HFF , &H3F , &HD1 , &H00

'Or in words:

'Set fuses for 16 MHz external crystal
'Startup time 16 CK + 64 ms
'Preserve EEPROM when chip is erased
'Set BOD-level to 4 Volt, and enable it
'Set Reset-vector to $0000

$hwstack = 48
$swstack = 16
$framesize = 40

$baud = 38400
$crystal = 16000000
$regfile = "m8def.dat"


Const Factor2 = 2533                                        '10^5/4*pi*pi

Dim Tmp_byte As Byte
Dim Tmp_word As Word
Dim Tmp_long As Long
Dim Tmp_single As Single

Dim Cnt_4ms As Byte

'Here we do the fancy trick again: overlay !
'Used for Elsie and Elm Low treshold values
Dim Cnts1_b1 As Byte
Dim Cnts1_b2 As Byte
Dim Cnts1_b3 As Byte
Dim Cnts1_b4 As Byte
Dim Cnts1_long As Long At Cnts1_b1 Overlay

'Used for Elm High treshold values
Dim Cnts2_b1 As Byte
Dim Cnts2_b2 As Byte
Dim Cnts2_b3 As Byte
Dim Cnts2_b4 As Byte
Dim Cnts2_long As Long At Cnts2_b1 Overlay

Dim Elm_cnt As Long

'Elm Calibration values in counts / pF
Dim Elm_high_range_cal As Single
Dim Ee_elm_high_range_cal As Eram Single
Dim Elm_low_range_cal As Single
Dim Ee_elm_low_range_cal As Eram Single

Dim Status As Byte
Dim Status_copy As Byte

Elm_selected Alias Status.7
Elm_large_caps Alias Status.6
Do_nulling Alias Status.5
Do_calibration Alias Status.4
Elcie_cap Alias Status.3
Elm_missed_it Alias Status.2
Elm_timeout Alias Status.1
Elm_ready Alias Status.0

Dim Elm_null_cnts As Long
Dim Ee_elm_null_cnts As Eram Long
Dim Elm_result As Single

Dim Teh_result As Single
Dim Teh_result_str As String * 16

Dim Unit_str As String * 16
Dim Empty_line_str As String * 16

Dim Elcie_f_null As Long
Dim Ee_elcie_f_null As Eram Long
Dim Elcie_f_dut As Long

Dim L_elcie_dut As Single
Dim C_elcie_dut As Single
Dim C_elcie_null As Single
Dim Ee_c_elcie_null As Eram Single
Dim L_elcie_null As Single
Dim Ee_l_elcie_null As Eram Single

'To prevent desastrous lock-up, prevent an Elcie measurement until
'both Nulling and Calibrating have been done
Dim Virgin_elcie As Byte
V_elcie_null Alias Virgin_elcie.0
V_elcie_cal Alias Virgin_elcie.1



Sw1_n Alias Pinc.3
Sw2_n Alias Pinc.2
Backlight_hi Alias Portb.1
Spkr Alias Portc.4
Do_l Alias Portb.0
Elm_disch Alias Ddrd.6
Elm_low_treshold Alias Ddrd.4
N_elm3k3_lm311on Alias Portd.3
Power_hold Alias Portd.2
Sw3_null Alias Pind.2

'setup i/o
Ddrc = &B00010011
Portc = &B00001100

Ddrb = &B00111111
Portb = &B00000000

'Pull -up On D.2 Enabled - - > Holds Power After Power -up
Ddrd = &B01011010
Portd = &B00000100


Config Lcdpin = Pin , Db4 = Portb.2 , Db5 = Portb.3 , Db6 = Portb.4 , Db7 = Portb.5 , E = Portc.0 , Rs = Portc.1
Config Lcd = 16 * 2

Config Adc = Single , Prescaler = Auto , Reference = Internal
Start Adc


'Initialize

'Timer2 is the time-base for Elcie, and is used as time-out for Elm
'setup to generate a compare int every 4 / 16 ms
'Setup CTC, OCR2 is top
Tccr2 = &B00001000                                          'CTC mode
Ocr2 = 249
On Oc2 Ms_int Nosave                                        '4 / 16 ms int handler
Enable Oc2
'For 1 second timing we use 4 ms interrupts:
'To start timer2, tccr2=tccr2 or &B00000110
'To stop Timer2,  tccr2=tccr2 and &B11111001
'For 4 second timing we use 16 ms interrupts:
'To start timer2, tccr2=tccr2 or &B00000111
'To stop Timer2,  tccr2=tccr2 and &B11111000

'Timer 1
'Elsie: counts the pulses from the LM311 on T1
'Tccr1a=0  'for reference only
'Tccr1b=0
'tccr1b=7 starts the counting of pulses on T1

'Elm:
'set tccr1b.cs10 to start counting with I/O-clock (16 MHz)

On Timer1 Timer1_ovf Nosave                                 'this int routine takes care of overflows
Enable Ovf1

'Analog Comparator used in Elm
On Aci Treshold_passed Nosave

Enable Interrupts

Empty_line_str = "                "

'###################################################################################
'Main:

Elm_high_range_cal = Ee_elm_high_range_cal
Elm_low_range_cal = Ee_elm_low_range_cal
C_elcie_null = Ee_c_elcie_null
L_elcie_null = Ee_l_elcie_null
Elcie_f_null = Ee_elcie_f_null

Elm_null_cnts = Ee_elm_null_cnts                            'restore from eeprom

'Wake up call
Gosub Do_okay_sound

Cls
Cursor Off Noblink

Lcd "Pre-flight3"
Home Lower


'Battery check
'Under full-load, the minimum allowed batteryvoltage is 7.35V = 490 ADC counts
'Less means that the 7805 will drop out of regulation

'set for min. current consumption
Set N_elm3k3_lm311on
Reset Backlight_hi
Reset Do_l

Tmp_word = Getadc(5)                                        'dummy read as it's the first
Waitms 1
Tmp_word = Getadc(5)                                        'ADC5= 0.18 * Ubatt

If Tmp_word < 490 Then
   Sound Spkr , 75 , 3000
   Lcd "Battery too LOW"
Else
   'max. current
   Reset N_elm3k3_lm311on
   Set Backlight_hi
   Set Do_l
   Waitms 200
   Tmp_word = Getadc(5)                                     'we want to check the battery level under max. current draw
   'restore min. current consumption
   Set N_elm3k3_lm311on
   Reset Backlight_hi
   Reset Do_l
   Tmp_word = Tmp_word - 450                                'to get a nice readout like a score in school
   Shift Tmp_word , Right , 4                               'divide by 16
   Lcd "Battery Q = " ; Tmp_word
End If

While Sw3_null = 0
Wend

Gosub Do_command_sound

Wait 1

'Default selected
Reset Elm_selected

'Default select for Elcie
Set Elcie_cap

Cls
Cursor Off Noblink

Do

'(

   'This block handles the buttons.
   'All it does is setting status-bits according to the required function

   'Switch off request by user
   If Sw1_n = 0 And Sw2_n = 0 And Sw3_null = 0 Then
      Sound Spkr , 25 , 5000
      Waitms 20
      Sound Spkr , 100 , 5000
      Power_hold = 0                                        '.... and go in power down
   End If
')

   'Nulling or Calibration request by user
   If Sw3_null = 1 Then
      If Sw2_n = 1 Then
         Set Do_nulling
      Else
         Set Do_calibration
      End If

   End If

'(

   'left button only
   If Sw1_n = 0 And Sw2_n = 1 And Sw3_null = 0 Then         'toggle between Elm and Elcie-inductive
      If Elm_selected = 1 Then
         Elm_selected = 0
         Elcie_cap = 0
      Else
         If Elcie_cap = 1 Then                              'when in Elcie-mode, switch to inductance measurement
            Elcie_cap = 0
         Else
            Elm_selected = 1                                'otherwise switch back to Elm-mode
            Elcie_cap = 1
         End If
      End If
      Gosub Do_okay_sound
      Waitms 500
   End If

   'Center button only
   If Sw1_n = 1 And Sw2_n = 0 And Sw3_null = 0 Then         'toggle between Elm and Elcie-capacitive
      If Elm_selected = 1 Then
         Elm_selected = 0
         Elcie_cap = 1
      Else
         If Elcie_cap = 0 Then                              'when in Elcie-mode, switch to capacitive measurement
            Elcie_cap = 1
         Else
            Elm_selected = 1                                'otherwise switch back to Elm-mode
            Elcie_cap = 1
         End If
      End If
      Gosub Do_okay_sound
      Waitms 500
   End If

   'Activate the Elcie-relay for inductance if necessary
   If Elm_selected = 0 And Elcie_cap = 0 Then
      Set Do_l
   Else
      Reset Do_l
   End If

')

   '---------------------------------------------------------------------------------------------

   'Forced Elcie-cap mode

      Reset N_elm3k3_lm311on                                'Turn on the LM311

      'User wants zero picofarad / zero micro-henry resp. on the display :)

      If Do_nulling = 1 Then
         Cls
         Gosub Do_command_sound
         If Elcie_cap = 1 Then
            Lcd "Remove DUT"
         Else
            Lcd "Bridge DUT"
         End If
         Home Lower
         Lcd "Press Null"
         While Sw3_null = 1
         Wend
         While Sw3_null = 0
         Wend
         Gosub Do_command_sound
         Waitms 200
         Cls
         Lcd "Nulling .."
         Home Lower
         Elcie_f_null = 0
         For Tmp_byte = 1 To 4
            Gosub Do_elcie
            Elcie_f_null = Elcie_f_null + Cnts1_long
            Lcd "..";
            Waitms 100
         Next Tmp_byte
         Shift Elcie_f_null , Right , 2                     'divide by 4
         Reset Do_nulling

         Ee_elcie_f_null = Elcie_f_null                     'store in EEprom

         Cls
         Lcd "Pre_flight_elcie"
         Home Lower
         Lcd "f_null " ; Elcie_f_null                       'and show user
         Gosub Do_okay_sound
         'Wait for user to push Button3
         While Sw3_null = 0
         Wend
         Gosub Do_command_sound
         Wait 1
         Cls

         Set V_elcie_null

      End If


      If Do_calibration = 1 Then
         Teh_result_str = "Conn. Cal_Elcie"
         Gosub Do_cal_display
         Cls
         Elcie_f_dut = 0
         Lcd "Calibrating .. "
         Home Lower
         For Tmp_byte = 1 To 4
            Gosub Do_elcie
            Elcie_f_dut = Elcie_f_dut + Cnts1_long
            Lcd "..";
            Waitms 100
         Next Tmp_byte
         Shift Elcie_f_dut , Right , 2                      'divide by 4

         'and now the math ...
         'We have Elcie_f_null, Elcie_f_dut (= Elcie_f_cal),
         'and we know the calibrated value of C_cal2
         'teh_term is an equasion we need more often, so it is put in a sub
         Gosub Teh_term
         Tmp_long = 1e9 / Elcie_f_null
         Tmp_long = Tmp_long * Tmp_long
         L_elcie_null = Tmp_single * Tmp_long
         L_elcie_null = L_elcie_null * Factor2              'Factor2 =10^5/4pi^2
         L_elcie_null = L_elcie_null / C_cal2
         L_elcie_null = L_elcie_null / 10000                'correction for units
         Ee_l_elcie_null = L_elcie_null                     'and store
         'we round the value
         'This has no influence on the accuracy: this value is used for setting the limits
         'for what we consider acceptable during Elmcie's lifetime (live long and prosper)
         L_elcie_null = Round(l_elcie_null)
         Tmp_word = L_elcie_null
         Cls
         Lcd "Pre_flight_l_"
         Home Lower
         Lcd "elcie_null " ; Tmp_word

         Gosub Do_okay_sound
         'Wait for user to push Button3
         While Sw3_null = 0
         Wend
         Gosub Do_command_sound
         Wait 1
         C_elcie_null = C_cal2 / Tmp_single
         C_elcie_null = C_elcie_null / 10
         Ee_c_elcie_null = C_elcie_null                     'and store
         'we round the value
         'This has no influence on the accuracy: this value is used for setting the limits
         'for what we consider acceptable during Elmcie's lifetime (live long and prosper)
         C_elcie_null = Round(c_elcie_null)
         Tmp_word = C_elcie_null
         Cls
         Lcd "Pre_flight_c_"
         Home Lower
         Lcd "elcie_null " ; Tmp_word

         Gosub Do_okay_sound
         'Wait for user to push Button3
         While Sw3_null = 0
         Wend
         Gosub Do_command_sound
         Wait 1
         Reset Do_calibration
         Wait 1
         Cls

         Set V_elcie_cal

      End If

      If V_elcie_cal = 1 And V_elcie_null = 1 Then

         Gosub Do_elcie

         If Elcie_cap = 1 Then                              'capacitive
            Elcie_f_dut = Cnts1_long
            Gosub Teh_term
            C_elcie_dut = Tmp_single * C_elcie_null

            Select Case C_elcie_dut
               Case Is < 1000
                  Teh_result = C_elcie_dut
                  Unit_str = " pF"
               Case Is >= 1000                              'ECN2008/2 see top of program
                  Teh_result = C_elcie_dut / 1000
                  Unit_str = " nF"
            End Select

         Else                                               'inductive

            If Cnts1_long < 10 Then                         'when there is no Ldut connected, display questionmarks
               Teh_result = -10000
               Unit_str = ""
            Else
               Elcie_f_dut = Cnts1_long
               Gosub Teh_term
               L_elcie_dut = Tmp_single * L_elcie_null
               Select Case L_elcie_dut
                  Case Is < 1000
                     Teh_result = L_elcie_dut
                     Unit_str = " uH"
                  Case Is > 1000
                     Teh_result = L_elcie_dut / 1000
                     Unit_str = " mH"
               End Select
            End If

         End If

       End If

   Gosub Do_display

Loop


End

'The End _ The End _ The End _ The End _ The End _ The End _ The End _ The End _ The End _ The End _


'####################################   Sub's      #####################################

Do_cal_display:

   Cls
   Gosub Do_command_sound
   Lcd "Calibration"
   Home Lower
   Lcd "release buttons"
   While Sw3_null = 1 Or Sw2_n = 0                          'wait for button release
   Wend
   Waitms 200
   Cls
   Gosub Do_command_sound
   Lcd Teh_result_str                                       'holds the instruction
   Home Lower
   Lcd "and press Null"
   While Sw3_null = 0                                       'wait for Null-button pressed
   Wend
   Waitms 200
   Gosub Do_command_sound

   Return


Do_okay_sound:

   Sound Spkr , 10 , 5000
   Waitms 100
   Sound Spkr , 30 , 2500

   Return


Do_error_sound_and_display:

   Sound Spkr , 100 , 10000
   Lcd " error"
   Wait 1

   Return

Do_command_sound:

   Sound Spkr , 100 , 1000

   Return

Teh_term:

   'This part of the program is needed twice; by making it a sub I freed some flash

   'To prevent an overflow on the square of the freq's, we need to do some tricks
   'For the real math, see end of this listing

   Tmp_long = Elcie_f_null
   Shift Tmp_long , Right , 4                               'tmp_long is a copy of Elcie_f_null/16
   Shift Elcie_f_dut , Right , 4
   'now it's safe to do a square
   Tmp_long = Tmp_long * Tmp_long
   Elcie_f_dut = Elcie_f_dut * Elcie_f_dut
   Tmp_single = Tmp_long / Elcie_f_dut
   Tmp_single = Tmp_single - 1                              'this term we keep as it's needed elsewhere

   Return

Do_display:

   'Enter this sub with the known teh_result and unit_str

   'A different handling for the pF- and uH-range is required
   If Unit_str = " pF" Or Unit_str = " uH" Then
      Teh_result_str = Fusing(teh_result , "#.#")
   Else
      Select Case Teh_result
         Case -10000
            Teh_result_str = "??? ...."
         Case Is < 10
            Teh_result_str = Fusing(teh_result , "#.###")
         Case 10 To 100
            Teh_result_str = Fusing(teh_result , "#.##")
         Case 100 To 1000
            Teh_result_str = Fusing(teh_result , "#.#")
         Case Is > 1000
            Teh_result = Int(teh_result)
            Teh_result_str = Str(teh_result)
      End Select
   End If

   Cls
   Lcd Teh_result_str ; Unit_str

   Locate 1 , 12
   If Elm_selected = 1 Then
      Lcd "Elm" ;
      If Elm_large_caps = 0 Then
         Lcd "Lo"
      Else
         Lcd "Hi"
      End If
   Else
      Lcd "LC" ;
      If Elcie_cap = 0 Then
         Lcd "ind"
      Else
         Lcd "cap"
      End If
   End If

   Waitms 500

   Return



Do_elcie:

   Cnt_4ms = 250
   Timer2 = 0
   Cnts1_long = 0
   Timer1 = 0
   Set Sfior.psr2                                           'clear the pre-scaler of timer2
   Tccr2 = Tccr2 Or &B00000110                              'start timer2
   Tccr1b = 7                                               'count external pulses on T1

   'Wait for 1 second int ; interrupt routine stops Timer1 and Timer2 when Cnt_4ms = 0
   While Cnt_4ms <> 0
   Wend
   'Timer1_overflow has been taken care of by the int routine
   'add contents of Timer1 to cnts1_long
   Cnts1_long = Cnts1_long + Timer1

   'And we return with .....
   'Cnts1_long as the frequncy of the LM311

   Return



'###################################     Int's     ########################################

Ms_int:

   push xl
   in  xl,sreg
   push xl

   lds xl,{Cnt_4ms}
   dec xl
   sts {Cnt_4ms},xl

   brne ms_int_exit                                         'if Cnt_4ms=0 then stop the timers HERE !
   ldi xl,0
   !out tccr1b,xl
   in xl,tccr2
   andi xl, &HF9
   !out tccr2,xl

   Ms_int_exit:
   pop xl
   !Out Sreg , Xl
   pop xl

   Return

'----------------------------------------------------------------------------------------------

Timer1_ovf:                                                 'now for 32 bit !

   push xl
   in  xl,sreg
   push xl

   lds xl,{Cnts1_b3}
   inc xl
   sts {Cnts1_b3},xl
   brne Timer1_ovf_exit                                     'done
   lds xl,{Cnts1_b4}
   inc xl
   sts {Cnts1_b4},xl

   Timer1_ovf_exit:
   pop xl
   !Out Sreg , Xl
   pop xl

   Return

'----------------------------------------------------------------------------------------------

Treshold_passed:

   push xl
   in  xl,sreg
   push xl

   'if ddrd.4=1 treshold is low, else we have the high one
   'Can also be done with SBIS or SBIC .... no need for T-bit-use
   in xl,ddrd
   bst xl,4                                                 'ddrd.4
   brtc high_tresh
   cbi ddrd,4                                               'set treshold high asap to prevent a second occurance
   in xl,tcnt1l                                             'the low treshold has been passed
   sts {cnts2_b1},xl                                        'so we store the 32 bit result in cnts2
   in xl,tcnt1h
   sts {cnts2_b2},xl
   lds xl, {Cnts1_b3}
   sts {cnts2_b3},xl
   lds xl, {Cnts1_b4}
   sts {cnts2_b4},xl                                        'cnts2_long holds now the 32 bit result of the first capture
   sbi Acsr,aci                                             'clear a possible flag
   rjmp Treshold_passed_exit

   High_tresh:
   in xl,tcnt1l
   sts {cnts1_b1},xl                                        'so we store the 32 bit result in cnts1
   in xl,tcnt1h
   sts {cnts1_b2},xl                                        'cnts1_long holds now the 32 bit result of the first capture
   lds xl,{status}
   sbr xl,1                                                 '!!! sets bit0
   sts {status},xl
   sbi ddrd,4                                               'to see end of measurement on scope
   cbi acsr,acie                                            'disable further interrupts
   sbi Acsr,aci                                             'clear a possible flag

   Treshold_passed_exit:
   pop xl
   !Out Sreg , Xl
   pop xl

   Return
